//@author: antokhio
//@help: template for compute shaders
//@tags: CS, template
//@credits: 

RWStructuredBuffer<uint> Output : BACKBUFFER;
StructuredBuffer<int> Select;
groupshared uint Count;

[numthreads(1, 1, 1)]
void CS( uint3 tid : SV_DispatchThreadID, uint3 gid : SV_GroupThreadID )
{
	if (gid.x ==  0)
	{
		Count = asuint (0.0f);
		//Output[0] = asuint (0.0f);
	}
	GroupMemoryBarrierWithGroupSync();
	
	uint f = asuint(Select[tid.x]);
	uint dummy;
	
	InterlockedAdd(Count, f, dummy);
	
	GroupMemoryBarrierWithGroupSync();
	
	if (gid.x == 0)
	{
		InterlockedAdd(Output[0], Count, dummy);
	}

}


technique11 Template
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}




